<?php
 namespace wpan\src; defined('PINYIN_DEFAULT') || define('PINYIN_DEFAULT', 4096); defined('PINYIN_TONE') || define('PINYIN_TONE', 2); defined('PINYIN_NO_TONE') || define('PINYIN_NO_TONE', 4); defined('PINYIN_ASCII_TONE') || define('PINYIN_ASCII_TONE', 8); defined('PINYIN_NAME') || define('PINYIN_NAME', 16); defined('PINYIN_KEEP_NUMBER') || define('PINYIN_KEEP_NUMBER', 32); defined('PINYIN_KEEP_ENGLISH') || define('PINYIN_KEEP_ENGLISH', 64); defined('PINYIN_UMLAUT_V') || define('PINYIN_UMLAUT_V', 128); defined('PINYIN_KEEP_PUNCTUATION') || define('PINYIN_KEEP_PUNCTUATION', 256); class Pinyin { private $_segmentsCount = 10; private $_defaultOptions; private $_wordsPath; private $_surnamesPath; public function __construct() { $this->_defaultOptions = PINYIN_DEFAULT; $this->_wordsPath = dirname(__DIR__) . '/data/words-%s.php'; $this->_surnamesPath = dirname(__DIR__) . '/data/surnames.php'; } public function convert($, $ = null) { $ = $ ? $ : $this->_defaultOptions; $ = $this->transform($, $); return $this->($, $); } public function name($, $ = null) { $ = $ ? $ : $this->_defaultOptions; $ = $ | \PINYIN_NAME; $ = $this->transform($, $); return $this->($, $); } public function permalink($, $ = '-', $ = null) { $ = $ ? $ : $this->_defaultOptions; if (\is_int($)) { $ = $; $ = "-"; } return implode($, $this->convert($, $ | \PINYIN_KEEP_NUMBER | \PINYIN_KEEP_ENGLISH)); } public function abbr($, $ = '', $ = null) { $ = $ ? $ : $this->_defaultOptions; if (is_numeric($)) { $ = $; $ = ""; } if ($this->($, \PINYIN_NAME)) { $ = $this->name($, $); } else { $ = $this->convert($, $ | \PINYIN_NO_TONE); } return implode($, array_map(function ($) { return \is_numeric($) || preg_match('/\\d+/', $) ? $ : \mb_substr($, 0, 1); }, $)); } public function phrase($, $ = ' ', $ = null) { $ = $ ? $ : $this->_defaultOptions; if (\is_int($)) { $ = $; $ = "-"; } return implode($, $this->convert($, $)); } public function sentence($, $ = ' ', $ = null) { $ = $ ? $ : $this->_defaultOptions; if (is_numeric($)) { $ = $; $ = " "; } $ = implode($, $this->convert($, $ | \PINYIN_KEEP_PUNCTUATION | \PINYIN_KEEP_ENGLISH | \PINYIN_KEEP_NUMBER)); return preg_replace('~\\s*(\\p{P})\\s*~u', '$1', $); } public function transform($, $ = null) { $ = $ ? $ : $this->_defaultOptions; $ = $this->($, $); if ($this->($, \PINYIN_NAME)) { $ = $this->($); } for ($ = 0; $ < $this->_segmentsCount; $++) { $ = strtr($, require sprintf($this->_wordsPath, $)); } return $; } private function ($) { $ = (require $this->_surnamesPath); foreach ($ as $ => $) { if (strpos($, $) === 0) { return $ . mb_substr($, mb_strlen($)); } } return $; } private function ($, $) { $ = array_filter(preg_split('/\\s+/i', $)); if (!$this->($, \PINYIN_TONE)) { foreach ($ as $ => $) { $[$] = $this->($, $); } } return array_values($); } private function ($, $) { return ($ & $) === $; } private function (string $, int $) : string { $ = preg_replace_callback('~[a-z0-9_-]+~i', function ($) { return "\t" . $[0]; }, $); $ = '\\x{3007}\\x{2E80}-\\x{2FFF}\\x{3100}-\\x{312F}\\x{31A0}-\\x{31EF}\\x{3400}-\\x{4DBF}\\x{4E00}-\\x{9FFF}\\x{F900}-\\x{FAFF}'; $ = array($, '\\p{Z}', '\\p{M}', "\t"); if ($this->($, \PINYIN_KEEP_NUMBER)) { $[] = '0-9'; } if ($this->($, \PINYIN_KEEP_ENGLISH)) { $[] = 'a-zA-Z'; } if ($this->($, \PINYIN_KEEP_PUNCTUATION)) { $[] = "\\p{P}"; } return preg_replace(sprintf('~[^%s]~u', implode($)), '', $); } private function (string $, int $ = \PINYIN_NO_TONE) : string { $ = ['üē' => ['ue', 1], 'üé' => ['ue', 2], 'üě' => ['ue', 3], 'üè' => ['ue', 4], 'ā' => ['a', 1], 'ē' => ['e', 1], 'ī' => ['i', 1], 'ō' => ['o', 1], 'ū' => ['u', 1], 'ǖ' => ['yu', 1], 'á' => ['a', 2], 'é' => ['e', 2], 'í' => ['i', 2], 'ó' => ['o', 2], 'ú' => ['u', 2], 'ǘ' => ['yu', 2], 'ǎ' => ['a', 3], 'ě' => ['e', 3], 'ǐ' => ['i', 3], 'ǒ' => ['o', 3], 'ǔ' => ['u', 3], 'ǚ' => ['yu', 3], 'à' => ['a', 4], 'è' => ['e', 4], 'ì' => ['i', 4], 'ò' => ['o', 4], 'ù' => ['u', 4], 'ǜ' => ['yu', 4]]; foreach ($ as $ => $) { if (strpos($, $) !== false) { $ = $[0]; if ($this->($, \PINYIN_UMLAUT_V) && 'yu' == $) { $ = 'v'; } $ = str_replace($, $, $) . ($this->($, PINYIN_ASCII_TONE) ? $[1] : ''); } } return $; } }